<template>
  <div>
    <div class="titulo">
      <div class="ruta">
        <v-breadcrumbs :items="breadcrumbs" :large="false">
          <template v-slot:divider>
            <v-icon>mdi-chevron-right</v-icon>
          </template>
        </v-breadcrumbs>
      </div>
      <strong>Gerentes</strong>
    </div>
    <div class="pl-10 pr-10 contSecc">
      <div class="titSec">Gerentes de Certificación de Calidad</div>
      <br />
      <div class="gris">
        <v-row>
          <v-col class="pb-sm-0" :cols="12" :sm="12" :md="5" :lg="5" :xl="4">
            <div class="CampoOblogario">
              Gerente
              <span class="tRojo">*</span>
            </div>
            <v-autocomplete
              v-model="searchGerente"
              :loading="isSearching"
              :items="metadata.gerentes"
              :search-input.sync="searchGerenteSync"
              clearable
              hide-no-data
              hide-details
              hide-selected
              item-text="gerente_descripcion"
              item-value="gerente"
              @change="getPeriodoInfo"
              placeholder="Escribe su nombre o número de empleado"
              label="Buscar Gerente"
              solo
              return-object
            />
          </v-col>
          <v-col class="pt-sm-0" :cols="12" :sm="12" :md="4" :lg="3" :xl="2">
            <!--<v-btn
              block
              class="mr-6 mt-md-3 mt-sm-0"
              depressed
              dark
              tile
              color="secundary"
              :class="[
                { desac: isLoadingPuntoContacto || !searchGerente }
              ]"
              @click="getPuntoContacto()"
              >Buscar Gerente</v-btn
            >-->
          </v-col>
        </v-row>
      </div>

      <template v-if="!isNoActivePuntoContacto || isPuntoContactoAsignado">
        <div class="titSec" v-show="infoPuntoContactoResult">
          Asignación de la franquicia
        </div>
        <div class="CampoOblogario" v-show="infoPuntoContactoResult">
          Campo requerido
          <span class="tRojo">*</span>
        </div>
      </template>
    </div>
  </div>
</template>
<script>
import { required } from "vuelidate/lib/validators";
import axios from "axios";
import store from "@/store";
const serviceLocalStorage = store.state.serviceLocalStorage;
const user = serviceLocalStorage.userToken();
const serviceCommons = store.state.serviceCommons;
export default {
  name: "Component-buscadorGerente",
  components: {},
  data() {
    return {
      serviceCommons,
      breadcrumbs: [
        {
          text: "Plataforma de Franquicia",
          disabled: false,
          exact: true,
          to: {
            name: "home",
          },
        },
        {
          text: "Modelo de Revisión en Sitio",
          disabled: true,
        },
        {
          text: "Buscadores",
          disabled: true,
        },
        {
          text: "Por Gerentes",
          disabled: true,
        },
      ],
      filtrosFechas: {},
      searchGerente: null,
      searchGerenteSync: null,
      metadata: {
        gerentes: [],
        franquicias: [],
        categoriasFranquicia: [],
        modelosFranquicia: [],
        formatosFranquicia: [],
      },
      isSearching: false,
      isLoadingPuntoContacto: false,
      isLoadingGerentes: false,
      isLoadingFranquicia: false,
      isDialogErrorValidation: false,
      isDialogSave: false,
      isDialogCancel: false,
      isNotFoundPuntoContacto: false,
      isNoActivePuntoContacto: false,
      isSavingAsignacion: false,
      defaultDataPuntoContacto: null,
      puntoContactoBackup: null,
      infoPuntoContactoResult: false,
      gerente: {
        id_gerente: null,
        nombre_gerente: null,
      },
    };
  },

  watch: {
    searchGerenteSync(val) {
      if (!val) {
        this.searchGerente = null;
        this.invokeDefaultEmpyDataGerente();
      }
    },
  },
  computed: {},
  methods: {
    getGerentes() {
      var self = this;
      self.isLoadingGerentes = true;
      axios
        .get("/franquicia/dashboard/consulta/secure/buscador/get/gerente")
        .then((response) => {
          if (response) {
            if (response.data.status_code === 200) {
              const data = response.data.data;
              if (data) {
                self.setGerentes(data);
              }
            }
          }
        })
        .catch((error) => {
          console.log(error);
        })
        .finally(function () {
          self.isLoadingGerentes = false;
        });
    },
    setGerentes(data) {
      if (data) {
        data = data.filter((item, index) => {
          item.gerente_descripcion =
            item.id_gerente + " - " + item.nombre_gerente;
          return item;
        });
      }
      this.metadata.gerentes = data;
    },

    snapshotDataPuntoContacto() {
      let gerente = JSON.stringify(this.gerente);
      this.defaultDataPuntoContacto = JSON.parse(gerente);
    },
    invokeDefaultEmpyDataGerente() {
      let gerente = JSON.parse(JSON.stringify(this.defaultDataPuntoContacto));
      this.gerente = gerente;
      this.$v.$reset();
    },
    irGerente() {
    
      if (this.searchGerente) {
        this.searchGerente.nombre = this.searchGerente.nombre_gerente;
        let negocio = { idNegocio: 1 };
        this.$router.push({
          name: "certificacion_calidad_gerente_dashboard",
          params: {
            gerente: this.serviceCommons.objectToBase64(this.searchGerente), //PENDIENTE INTEGRAR WS
            isDirector: this.serviceCommons.objectToBase64({ value: true }),
            negocio: this.serviceCommons.objectToBase64(negocio), //PENDIENTE INTEGRAR WS
            filtrosFechas: this.serviceCommons.objectToBase64(
              this.filtrosFechas
            ),
          },
        });
      }
    },
    getPeriodoInfo() {
      const self = this;
      axios
        .get("franquicia/periodo/secure/get/actual")
        .then((response) => {
          if (response) {
            if (response.data.status_code === 200) {
              const data = response.data.data;
              if (data) {
                //Se comenta el bimestre para traer solo fechas del trimestre.
                //PENDIENTE Parametrizar el periodo.
                data.bimestre = null;
                //data.trimestre = data.trimestre - 1;
                delete data.festivo;
                self.getFechasPeriodo(data);
              }else{
                self.filtrosFechas.fechaInicio = "01/01/2021";
                self.filtrosFechas.fechaFin = "31/03/2021";
                self.irGerente();
              }
            }
          }
        })
        .catch((error) => {
          console.log(error);
        });
    },
    getFechasPeriodo(periodo) {
      const self = this;
      axios
        .post("franquicia/periodo/secure/get/fechas", periodo)
        .then((response) => {
          if (response) {
            if (response.data.status_code === 200) {
              const data = response.data.data;
              if (data) {
                self.filtrosFechas.fechaInicio = data.fecha_inicio;
                self.filtrosFechas.fechaFin = data.fecha_fin;
                //self.filtrosFechas.fechaInicio = "01/07/2020";
                // self.filtrosFechas.fechaFin = "30/09/2020";
                self.irGerente();
              }
            }
          }
        })
        .catch((error) => {
          console.log(error);
        });
    },
  },
  created() {
    this.snapshotDataPuntoContacto();
    this.getGerentes();
  },
};
</script>
